/* Code generated by IfcQuery EXPRESS generator, www.ifcquery.com */
#include "ifcpp/model/AttributeObject.h"
#include "ifcpp/model/BuildingException.h"
#include "ifcpp/model/BuildingGuid.h"
#include "ifcpp/reader/ReaderUtil.h"
#include "ifcpp/writer/WriterUtil.h"
#include "ifcpp/IFC4X3/include/IfcActorRole.h"
#include "ifcpp/IFC4X3/include/IfcAddress.h"
#include "ifcpp/IFC4X3/include/IfcIdentifier.h"
#include "ifcpp/IFC4X3/include/IfcLabel.h"
#include "ifcpp/IFC4X3/include/IfcPerson.h"
#include "ifcpp/IFC4X3/include/IfcPersonAndOrganization.h"

// ENTITY IfcPerson 
IFC4X3::IfcPerson::IfcPerson( int tag ) { m_tag = tag; }
void IFC4X3::IfcPerson::getStepLine( std::stringstream& stream, size_t precision ) const
{
	stream << "#" << m_tag << "= IFCPERSON" << "(";
	if( m_Identification ) { m_Identification->getStepParameter( stream, false, precision ); } else { stream << "$"; }
	stream << ",";
	if( m_FamilyName ) { m_FamilyName->getStepParameter( stream, false, precision ); } else { stream << "$"; }
	stream << ",";
	if( m_GivenName ) { m_GivenName->getStepParameter( stream, false, precision ); } else { stream << "$"; }
	stream << ",";
	if( m_MiddleNames.size() > 0 )
	{
		stream << "(";
		for( size_t ii = 0; ii < m_MiddleNames.size(); ++ii )
		{
			if( ii > 0 )
			{
				stream << ",";
			}
			const shared_ptr<IfcLabel>& type_object = m_MiddleNames[ii];
			if( type_object )
			{
				type_object->getStepParameter( stream, false, precision );
			}
			else
			{
				stream << "$";
			}
		}
		stream << ")";
	}
	else { stream << "$"; }
	stream << ",";
	if( m_PrefixTitles.size() > 0 )
	{
		stream << "(";
		for( size_t ii = 0; ii < m_PrefixTitles.size(); ++ii )
		{
			if( ii > 0 )
			{
				stream << ",";
			}
			const shared_ptr<IfcLabel>& type_object = m_PrefixTitles[ii];
			if( type_object )
			{
				type_object->getStepParameter( stream, false, precision );
			}
			else
			{
				stream << "$";
			}
		}
		stream << ")";
	}
	else { stream << "$"; }
	stream << ",";
	if( m_SuffixTitles.size() > 0 )
	{
		stream << "(";
		for( size_t ii = 0; ii < m_SuffixTitles.size(); ++ii )
		{
			if( ii > 0 )
			{
				stream << ",";
			}
			const shared_ptr<IfcLabel>& type_object = m_SuffixTitles[ii];
			if( type_object )
			{
				type_object->getStepParameter( stream, false, precision );
			}
			else
			{
				stream << "$";
			}
		}
		stream << ")";
	}
	else { stream << "$"; }
	stream << ",";
	writeEntityList( stream, m_Roles );
	stream << ",";
	writeEntityList( stream, m_Addresses );
	stream << ");";
}
void IFC4X3::IfcPerson::getStepParameter( std::stringstream& stream, bool /*is_select_type*/, size_t /*precision*/ ) const { stream << "#" << m_tag; }
void IFC4X3::IfcPerson::readStepArguments( const std::vector<std::string>& args, const std::map<int,shared_ptr<BuildingEntity> >& map, std::stringstream& errorStream )
{
	const size_t num_args = args.size();
	if( num_args > 0 ){m_Identification = IfcIdentifier::createObjectFromSTEP( args[0], map, errorStream );}
	if( num_args > 1 ){m_FamilyName = IfcLabel::createObjectFromSTEP( args[1], map, errorStream );}
	if( num_args > 2 ){m_GivenName = IfcLabel::createObjectFromSTEP( args[2], map, errorStream );}
	if( num_args > 3 ){readTypeOfStringList( args[3], m_MiddleNames );}
	if( num_args > 4 ){readTypeOfStringList( args[4], m_PrefixTitles );}
	if( num_args > 5 ){readTypeOfStringList( args[5], m_SuffixTitles );}
	if( num_args > 6 ){readEntityReferenceList( args[6], m_Roles, map, errorStream );}
	if( num_args > 7 ){readEntityReferenceList( args[7], m_Addresses, map, errorStream );}
	if( num_args != 8 ){ errorStream << "Wrong parameter count for entity IfcPerson, expecting 8, having " << num_args << ". Entity ID: " << m_tag << std::endl; }
}
void IFC4X3::IfcPerson::getAttributes( std::vector<std::pair<std::string, shared_ptr<BuildingObject> > >& vec_attributes ) const
{
	vec_attributes.emplace_back( std::make_pair( "Identification", m_Identification ) );
	vec_attributes.emplace_back( std::make_pair( "FamilyName", m_FamilyName ) );
	vec_attributes.emplace_back( std::make_pair( "GivenName", m_GivenName ) );
	shared_ptr<AttributeObjectVector> MiddleNames_vec_object( new AttributeObjectVector() );
	std::copy( m_MiddleNames.begin(), m_MiddleNames.end(), std::back_inserter( MiddleNames_vec_object->m_vec ) );
	vec_attributes.emplace_back( std::make_pair( "MiddleNames", MiddleNames_vec_object ) );
	shared_ptr<AttributeObjectVector> PrefixTitles_vec_object( new AttributeObjectVector() );
	std::copy( m_PrefixTitles.begin(), m_PrefixTitles.end(), std::back_inserter( PrefixTitles_vec_object->m_vec ) );
	vec_attributes.emplace_back( std::make_pair( "PrefixTitles", PrefixTitles_vec_object ) );
	shared_ptr<AttributeObjectVector> SuffixTitles_vec_object( new AttributeObjectVector() );
	std::copy( m_SuffixTitles.begin(), m_SuffixTitles.end(), std::back_inserter( SuffixTitles_vec_object->m_vec ) );
	vec_attributes.emplace_back( std::make_pair( "SuffixTitles", SuffixTitles_vec_object ) );
	shared_ptr<AttributeObjectVector> Roles_vec_object( new AttributeObjectVector() );
	std::copy( m_Roles.begin(), m_Roles.end(), std::back_inserter( Roles_vec_object->m_vec ) );
	vec_attributes.emplace_back( std::make_pair( "Roles", Roles_vec_object ) );
	shared_ptr<AttributeObjectVector> Addresses_vec_object( new AttributeObjectVector() );
	std::copy( m_Addresses.begin(), m_Addresses.end(), std::back_inserter( Addresses_vec_object->m_vec ) );
	vec_attributes.emplace_back( std::make_pair( "Addresses", Addresses_vec_object ) );
}
void IFC4X3::IfcPerson::getAttributesInverse( std::vector<std::pair<std::string, shared_ptr<BuildingObject> > >& vec_attributes_inverse ) const
{
	shared_ptr<AttributeObjectVector> EngagedIn_inverse_vec_obj( new AttributeObjectVector() );
	for( size_t i=0; i<m_EngagedIn_inverse.size(); ++i )
	{
		if( !m_EngagedIn_inverse[i].expired() )
		{
			EngagedIn_inverse_vec_obj->m_vec.emplace_back( shared_ptr<IfcPersonAndOrganization>( m_EngagedIn_inverse[i] ) );
		}
	}
	vec_attributes_inverse.emplace_back( std::make_pair( "EngagedIn_inverse", EngagedIn_inverse_vec_obj ) );
}
void IFC4X3::IfcPerson::setInverseCounterparts( shared_ptr<BuildingEntity> ptr_self_entity )
{
	shared_ptr<IfcPerson> ptr_self = dynamic_pointer_cast<IfcPerson>( ptr_self_entity );
	if( !ptr_self ) { throw BuildingException( "IfcPerson::setInverseCounterparts: type mismatch" ); }
	for( size_t i=0; i<m_Addresses.size(); ++i )
	{
		if( m_Addresses[i] )
		{
			m_Addresses[i]->m_OfPerson_inverse.emplace_back( ptr_self );
		}
	}
}
void IFC4X3::IfcPerson::unlinkFromInverseCounterparts()
{
	for( size_t i=0; i<m_Addresses.size(); ++i )
	{
		if( m_Addresses[i] )
		{
			std::vector<weak_ptr<IfcPerson> >& OfPerson_inverse = m_Addresses[i]->m_OfPerson_inverse;
			for( auto it_OfPerson_inverse = OfPerson_inverse.begin(); it_OfPerson_inverse != OfPerson_inverse.end(); )
			{
				weak_ptr<IfcPerson> self_candidate_weak = *it_OfPerson_inverse;
				if( self_candidate_weak.expired() )
				{
					++it_OfPerson_inverse;
					continue;
				}
				shared_ptr<IfcPerson> self_candidate( *it_OfPerson_inverse );
				if( self_candidate.get() == this )
				{
					it_OfPerson_inverse= OfPerson_inverse.erase( it_OfPerson_inverse );
				}
				else
				{
					++it_OfPerson_inverse;
				}
			}
		}
	}
}
